Option Strict On

Imports System
Imports System.Threading
Imports System.ComponentModel
Imports tine
Imports NPlot

Public Class Form1
  Dim tdt As tine.TDataType
  Dim tnull As tine.TDataType
  Dim currBuffer(79) As Single
  Dim dataX(79) As Double
  Dim dataY(79) As Double
  Dim currLink As tine.TLink
  Dim bunProfAxis As List(Of Double) = New List(Of Double)
  Dim bunProfCurve As List(Of Double) = New List(Of Double)

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim i As Integer

    ''Add a background grid for better chart readability.
    Dim grid As Grid = New Grid()
    grid.VerticalGridType = grid.GridType.Coarse
    grid.HorizontalGridType = grid.GridType.Coarse
    grid.MajorGridPen = New Pen(Color.LightGray, 1.0F)

    bunchProfile.Add(grid)
    Dim bunProf As LinePlot = New LinePlot()
    bunProf.Pen = New Pen(Color.Green, 2)

    For i = 0 To 79
      dataX(i) = i
      bunProfAxis.Add(dataX(i))
      bunProfCurve.Add(dataY(i))
    Next

    bunProf.AbscissaData = bunProfAxis
    bunProf.DataSource = bunProfCurve
    bunchProfile.Add(bunProf)
    ''  //Balance plot general settings.
    bunchProfile.ShowCoordinates = True
    bunchProfile.YAxis1.Label = "Bunch Profile"
    bunchProfile.YAxis1.LabelOffsetAbsolute = True
    bunchProfile.YAxis1.WorldMax = 10
    bunchProfile.YAxis1.WorldMin = 0
    bunchProfile.YAxis1.LabelOffset = 40
    bunchProfile.XAxis1.HideTickText = True
    bunchProfile.Padding = 5

    bunchProfile.Refresh()
  End Sub
  Public Sub updatePlot()
    Dim i As Integer
    bunProfCurve.Clear()
    For i = 0 To 78
      dataY(i) = currBuffer(i)
      bunProfCurve.Add(dataY(i))
    Next
    bunchProfile.Refresh()
  End Sub
  Public Sub lcb(ByVal lnk As tine.TLink)
    If bunchProfile.InvokeRequired Then
      bunchProfile.Invoke(New MethodInvoker(AddressOf updatePlot))
    Else
      updatePlot()
    End If
  End Sub
  Dim cb As TLink.TLinkCallback

  Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    Dim id As Integer
    cb = New TLink.TLinkCallback(AddressOf lcb)
    tdt = New TDataType(currBuffer)
    tnull = New TDataType(IntPtr.Zero)
    currLink = New TLink()
    id = currLink.Attach("/PETRA/BunchScope/Bunch-1", "BunchTrace.SCH", tdt, tnull, tine.Access.CA_READ, 1000, cb, tine.Modes.CM_DATACHANGE, 0, IntPtr.Zero)

  End Sub
End Class
